grails-app/domain/com/mbds/grails/User.groovy
package com.mbds.grails

import groovy.transform.EqualsAndHashCode
import groovy.transform.ToString
import grails.compiler.GrailsCompileStatic

@GrailsCompileStatic
@EqualsAndHashCode(includes='username')
@ToString(includes='username', includeNames=true, includePackage=false)
class User implements Serializable {

    private static final long serialVersionUID = 1

    String username
    String password
    boolean enabled = true
    boolean accountExpired
    boolean accountLocked
    boolean passwordExpired

    static hasMany = [annonces: Annonce]

    Set<Role> getAuthorities() {
        (UserRole.findAllByUser(this) as List<UserRole>)*.role as Set<Role>
    }

    static constraints = {
        password nullable: false, blank: false, password: true
        username nullable: false, blank: false, unique: true
    }

    static mapping = {
	    password column: '`password`'
    }
}

grails-app/controllers/com/mbds/grails/UserController.groovy
package com.mbds.grails

import org.bouncycastle.openssl.PasswordException
import org.springframework.security.access.annotation.Secured

import javax.xml.bind.ValidationException

import static org.springframework.http.HttpStatus.*

class UserController {

    UserService userService

    static allowedMethods = [save: "POST", update: "PUT", delete: "DELETE"]

    @Secured(["ROLE_MODO", "ROLE_ADMIN"])
    def index(Integer max) {
        params.max = Math.min(max ?: 10, 100)
        respond userService.list(params), model: [userCount: userService.count()]
    }

    @Secured(["ROLE_MODO", "ROLE_ADMIN"])
    def show(Long id) {
        def user = userService.get(id)
        respond user, model: [annonceList: Annonce.findAllByAuthor(user), userRole: UserRole.findByUser(user)]
    }

    @Secured(["ROLE_ADMIN"])
    def create() {
        respond new User(params), model: [rolelist: Role.findAll()]
    }

    @Secured(["ROLE_ADMIN"])
    def save() {
        //render(params)
        def user = null
        try {
            user = userService.save(params)
            if (user == null) {
                notFound()
                return
            }
        } catch (ValidationException e) {
            respond user.errors, view: 'create'
            return
        } catch (PasswordException exp) {
            respond exp.getMessage(), view: 'create'
            return
        }
        request.withFormat {
            form multipartForm {
                flash.message = "Utilisateur créée avec succès "
                redirect user
            }
            '*' { respond user, [status: CREATED] }
        }
    }

    @Secured(["ROLE_ADMIN"])
    def edit(Long id) {
        def user = userService.get(id)
        respond user, model: [annonceList: Annonce.findAllByAuthor(user), rolelist: Role.findAll(), userRole: UserRole.findByUser(user)]
    }

//    @Secured(["ROLE_MODO", "ROLE_ADMIN"])
    @Secured(["ROLE_ADMIN"])
    def update() {
        def user = null
        try {
            user = userService.update(params)
            if (user == null) {
                notFound()
                return
            }
        } catch (Exception ex) {
            redirect(action: "edit", id: params.id)
            flash.error = ex.getMessage()
            return
        }

        request.withFormat {
            form multipartForm {
                flash.message = "Utilisateur modifié avec succès "
                redirect user
            }
            '*' { respond user, [status: OK] }
        }
    }

    @Secured(["ROLE_ADMIN"])
    def delete(Long id) {
        if (id == null) {
            notFound()
            return
        }

        userService.delete(id)

        request.withFormat {
            form multipartForm {
                flash.message = "Utilisateur supprimé avec succès"
                redirect action: "index", method: "GET"
            }
            '*' { render status: NO_CONTENT }
        }
    }

    @Secured(["ROLE_MODO", "ROLE_ADMIN"])
    protected void notFound() {
        request.withFormat {
            form multipartForm {
                flash.message = message(code: 'default.not.found.message', args: [message(code: 'user.label', default: 'User'), params.id])
                redirect action: "index", method: "GET"
            }
            '*' { render status: NOT_FOUND }
        }
    }
}

grails-app/views/user/create.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="disposition"/>
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}"/>
    <title><g:message code="default.create.label" args="[entityName]"/></title>
</head>

<body>

<div class="container-fluid">

    <!-- Page Heading
    <h1 class="h3 mb-2 text-gray-800">Poster une annonce</h1>-->

    <!-- DataTales Example -->
    <div class="card shadow mb-4">
        <div class="card-header py-3">
            <h6 class="m-0 font-weight-bold text-primary"><h6 class="m-0 font-weight-bold ">Ajouter un utilisateur</h6></h6>
        </div>
        <g:if test="${flash.message}">
            <div class="message" role="status">${flash.message}</div>
        </g:if>
        <g:hasErrors bean="${this.user}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.user}" var="error">
                    <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message
                            error="${error}"/></li>
                </g:eachError>
            </ul>
        </g:hasErrors>
        <g:form resource="${this.user}" method="POST">
            <div class="card-body">
                <div class="input-group required">
                    <label class="col-sm-4" for="username">Nom
                        <span class="required-indicator">*</span>
                    </label><input type="text" name="username" value="${user.username}" required=""
                                   class="form-control col-sm-6"
                                   id="username">
                </div>
                 <hr>
                <div class="input-group" style="margin-bottom: 15px;">
                    <label class="col-sm-4">Role
                        <span class="required-indicator">*</span>
                    </label>
                    <g:select id="role" class="form-control col-sm-6" required="" name="role.id"
                              from="${rolelist}"
                              optionKey="id" optionValue="authority"/>
                </div>
                <hr>
                <div class="input-group">
                    <label class="col-sm-4" for="password">Nouveau mot de passe
                        <span class="required-indicator">*</span>
                    </label><input type="password" name="password" required=""
                                   class="form-control col-sm-6"
                                   value=""
                                   id="password">
                </div>
                <br>

                <div class="input-group">
                    <label class="col-sm-4" for="password">Confirmation mot de passe
                        <span class="required-indicator">*</span>
                    </label><input type="password"  required=""
                                   class="form-control col-sm-6" name="conf_password"
                                   value="" id="confirm_password">

                </div>
                <small id='message' class="offset-4"></small>
                <hr>
                <fieldset class="buttons">
                    <g:submitButton name="create" id="btnModifMdp" class="btn btn-success"
                                    value="Ajouter"/>
                </fieldset>
            </div>
        </g:form>
    </div>
</div>
</body>
</html>

grails-app/views/user/edit.gsp
<!DOCTYPE html>
<html>
<head>
    <meta name="layout" content="disposition"/>
    <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}"/>
    <title>Modifier l'utilisateur</title>
</head>

<body>
<div class="container-fluid">
    <g:if test="${flash.message}">
        <div class="alert alert-success col-lg-4" role="status">${flash.message} &nbsp; &nbsp; <asset:image
                src="checked.png"></asset:image></div>
    </g:if>
    <g:if test="${flash.error}">
        <div class="alert alert-danger col-lg-5" role="status">${flash.error} &nbsp; &nbsp; <asset:image class="float-right"
                src="warning.png"></asset:image></div>
    </g:if>
    <div class="card shadow mb-4">
        <div class="card-header py-3">
            <h6 class="m-0 font-weight-bold ">Modifier l'utilisateur</h6>
        </div>
        <g:hasErrors bean="${this.user}">
            <ul class="errors" role="alert">
                <g:eachError bean="${this.user}" var="error">
                    <li <g:if test="${error in org.springframework.validation.FieldError}">data-field-id="${error.field}"</g:if>><g:message
                            error="${error}"/></li>
                </g:eachError>
            </ul>
        </g:hasErrors>
        <g:form resource="${this.user}" method="PUT">
            <g:hiddenField name="version" value="${this.user?.version}"/>
            <div class="card-body">
                <div class="input-group required">
                    <label class="col-sm-2" for="username">Nom
                    </label><input type="text" name="username" value="${user.username}" required=""
                                   class="form-control col-sm-6" id="username">

                </div>
                <hr>
                <div class="input-group" style="margin-bottom: 15px;">
                    <label class="col-sm-2">Role
                    </label>
                    <g:select id="role" class="form-control col-sm-6" required="" name="role.id"
                              from="${rolelist}" optionKey="id" optionValue="authority" value="${userRole.role.id}"/>
                </div>
                <hr>
                <div class="input-group">
                    <label class="col-sm-2" for="password">Nouveau mot de passe :
                    </label><input type="password" name="password"  class="form-control col-sm-6" id="password">
                </div>
                <br>

                <div class="input-group">
                    <label class="col-sm-2" for="confirm_password">Confirmation mot de passe :
                    </label><input type="password" name="conf_password"  class="form-control col-sm-6" value="" id="confirm_password">
                </div>
                <small id='message' class="offset-2"></small>
                <hr>
                <div class="input-group required">
                    <label class="col-sm-3" for="passwordExpired">Mot de passe expiré</label>
                    <g:checkBox type="checkbox" name="passwordExpired" class=" col-sm-1" id="passwordExpired"
                                value="${user.passwordExpired}" checked="${user.passwordExpired}"/>
                    <label class="col-sm-2" for="accountLocked">Compte bloqué</label>
                    <g:checkBox type="checkbox" name="accountLocked" class="col-sm-1" id="accountLocked"
                                value="${user.accountLocked}" checked="${user.accountLocked}"/>
                </div>
                <hr>

                <div class="input-group">
                    <label class="col-sm-3" for="accountExpired">Compte expiré</label>
                    <g:checkBox type="checkbox" name="accountExpired" class=" col-sm-1" id="accountExpired"
                                value="${user.accountExpired}" checked="${user.accountExpired}"/>
                    <label class="col-sm-2" for="enabled">Activé</label>
                    <g:checkBox type="checkbox" class="col-sm-1"
                                name="enabled" id="enabled" value="${user.enabled}" checked="${user.enabled}"/>
                </div>
                <hr>

                <div class="input-group">
                    <label class="col-sm-4">Liste des Annonces :</label>

                    <div class="col-sm-3"><a href="/projet/annonce/create?user.id=1" class="btn btn-success"><i
                            class="fas fa-plus-circle"></i>&nbsp;Ajouter une annonce</a></div>
                </div>
                <br>

                <div>
                    <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                        <thead>
                        <tr class="info">
                            <th>Titre</th>
                            <th>Description</th>
                            <th>Prix</th>
                            <th>Illustrations</th>
                            <th>Auteur</th>
                            <th></th>
                        </tr>
                        </thead>
                        <tbody>
                        <g:each in="${annonceList}" var="annonce">
                            <tr>
                                <th>${annonce.title}</th>
                                <th>${annonce.description}</th>
                                <th>${annonce.price}</th>
                                <th>
                                    <g:each in="${annonce.illustrations}" var="illustration">
                                        <img src="${grailsApplication.config.annonces.illustrations.url + illustration.filename}"
                                             class="img-thumbnail" width="100" height="100"/>
                                    </g:each>
                                </th>
                                <th>${annonce.author.username}</th>
                                <th><a href="/projet/annonce/show/${annonce.id}" class="btn btn-outline-warning">
                                    Voir détail
                                </th>
                            </tr>
                        </g:each>
                        </tbody>
                    </table>
                </div>
                <br>
                <fieldset class="buttons">
                    <input class="btn btn-success" type="submit"
                           value='Modifier'/>
                </fieldset>
            </div>
        </g:form>
    </div>
</div>
</body>
</html>

grails-app/views/user/index.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="disposition" />
        <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}" />
        <title>Listes des utilisateurs</title>
    </head>
    <body>
    <div class="container-fluid">
        <!-- Page Heading    <h1 class="h3 mb-2 text-gray-800">Gestion des Utilisateurs</h1> -->
        <!-- DataTales Example -->
        <div class="card shadow mb-4">
            <div class="card-header py-3">
                <div class="row">
                <h6 class="m-0 font-weight-bold col-sm-10">Liste des utilisateurs</h6>
                    <a href="create" class="btn btn-success btn-sm col-sm-1">
                        Ajouter  <i class="fas fa-plus"></i>
                    </a>
                </div>
            </div>
            <div class="card-body">
                <div class="table-responsive">
                    <table class="table table-bordered"  width="100%" cellspacing="0">
                        <thead>
                        <tr>
                            <th>Nom</th>
                            <th>Role</th>
                            <th>Action</th>
                        </tr>
                        </thead>
                        <tbody>
                        <g:each in="${userList}" var="user">
                            <tr>
                                <th><a href="show/${user.id}" class="text-info">${user.username}</a></th>
                                <th><g:each in="${user.getAuthorities()}" var="role">
                                    ${role.authority}
                                </g:each></th>
                                <th><a href="edit/${user.id}" class="btn btn-info">
                                    <i class="fas fa-edit"></i>
                                </a> <a data-toggle="modal" data-target="#supprimer${user.id}" class="btn btn-danger">
                                    <i class="fas fa-trash"></i>
                                </a></th>
                            </tr>
                            <div class="modal fade" id="supprimer${user.id}" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
                                 aria-hidden="true">
                                <div class="modal-dialog" role="document">
                                    <div class="modal-content">
                                        <div class="modal-header">
                                            <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                                                <span aria-hidden="true">×</span>
                                            </button>
                                        </div>
                                        <div class="modal-body">Voulez vous vraiment supprimer cet utilisateur ?</div>
                                        <div class="modal-footer">
                                            <form action="/projet/user/delete/${user.id}" method="post"><input type="hidden" name="_method" value="DELETE" id="_method">
                                                <button class="btn btn-secondary" type="button" data-dismiss="modal">Annuler</button>
                                                <input type="submit" class="btn btn-danger" value="Oui">
                                            </form>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </g:each>
                        </tbody>
                    </table>

                </div>
                <g:paginate total="${userCount ?: 0}" />
            </div>
        </div>

    </div>

    </body>
</html>

grails-app/views/user/show.gsp
<!DOCTYPE html>
<html>
    <head>
        <meta name="layout" content="disposition" />
        <g:set var="entityName" value="${message(code: 'user.label', default: 'User')}" />
        <title>Détail de l'utilisateur</title>
    </head>
    <body>
    <div class="container-fluid">
        <!-- Page Heading  <h1 class="h3 mb-2 text-gray-800">Detail de l'annonce</h1>  -->

        <!-- DataTales Example -->
        <g:if test="${flash.message}">
            <div class="alert alert-success col-lg-5" role="status">${flash.message} &nbsp; &nbsp; &nbsp;<asset:image src="checked.png" class="float-right"></asset:image></div>
        </g:if>
        <div class="card shadow mb-4">
            <div class="card-header py-3">
                <h6 class="m-0 font-weight-bold text-truncate">Détail de l'utilisateur</h6>
            </div>
            <div class="card-body">
                <div class="row" style="margin-bottom: 15px;">
                    <label class="col-sm-4 text-info">Nom d'utilisateur :</label>
                    <label class="col-sm-4">${user.username}</label>
                </div>
                <div class="row" style="margin-bottom: 15px;">
                    <label class="col-sm-4 text-info">Role :</label>
                    <label class="col-sm-4">${userRole.role.authority}</label>
                </div>
                <div class="row" style="margin-bottom: 15px;">
                    <label class="col-sm-4 text-info">Mot de passe expiré :</label>
                    <label class="col-sm-4">${user.passwordExpired}</label>
                </div>

                <div class="row" style="margin-bottom: 15px;">
                    <label class="col-sm-4 text-info">Compte activé  :</label>
                    <label class="col-sm-4">${user.enabled}</label>
                </div>
                <div class="row" style="margin-bottom: 15px;">
                    <label class="col-sm-4 text-info">Compte bloqué  :</label>
                    <label class="col-sm-4">${user.accountLocked}</label>
                </div>
                <div class="row" style="margin-bottom: 15px;">
                    <label class="col-sm-4 text-info">Compte expiré  :</label>
                    <label class="col-sm-4">${user.accountExpired}</label>
                </div>
                <div class="row">
                    <label class="col-sm-7 text-info" for="annonces">Liste des Annonces :</label>
                </div>
                <br>

                <div>
                    <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                        <thead>
                        <tr class="info">
                            <th>Titre</th>
                            <th>Description</th>
                            <th>Prix</th>
                            <th>Illustrations</th>
                            <th>Auteur</th>
                            <th></th>
                        </tr>
                        </thead>
                        <tbody>
                        <g:each in="${annonceList}" var="annonce">
                            <tr>
                                <th>${annonce.title}</th>
                                <th>${annonce.description}</th>
                                <th>${annonce.price}</th>
                                <th>
                                    <g:each in="${annonce.illustrations}" var="illustration">
                                        <img src="${grailsApplication.config.annonces.illustrations.url + illustration.filename}"  class="img-thumbnail" width="100" height="100"/>
                                    </g:each>
                                </th>
                                <th>${annonce.author.username}</th>
                                <th><a href="/projet/annonce/show/${annonce.id}" class="btn btn-outline-warning">
                                    Voir détail</a></th>
                            </tr>
                        </g:each>
                        </tbody>
                    </table>
                </div>
                </br>
                <div>
                <a href="/projet/user/edit/${user.id}" class="btn btn-info btn-sm">
                    <i class="fas fa-edit"></i>&nbsp;Modifier</a>
                <a  class="btn btn-danger btn-sm" data-toggle="modal" data-target="#supprimer_annonce">
                    <i class="fas fa-trash"></i>&nbsp;Supprimer</a>
                </div>
                <div class="modal fade" id="supprimer_annonce" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel"
                     aria-hidden="true">
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <button class="close" type="button" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">×</span>
                                </button>
                            </div>
                            <div class="modal-body">Voulez vous vraiment supprimer cet utilisateur ?</div>
                            <div class="modal-footer">
                                <form action="/projet/user/delete/${user.id}" method="post"><input type="hidden" name="_method" value="DELETE" id="_method">
                                    <button class="btn btn-light" type="button" data-dismiss="modal">Annuler</button>
                                    <input type="submit" class="btn btn-danger" value="Oui">
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    </body>
</html>